{
This is part of AY Emulator project
AY-3-8910/12 Emulator
Version 2.8 for Windows 95
Author Sergey Vladimirovich Bulba
(c)1999-2006 S.V.Bulba
}

unit Tools;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, FileCtrl, ShlObj, ComObj, ActiveX, ExtCtrls, Buttons;

const
 NOfIcons = 14;
 IconAuthors:array[0..NOfIcons] of string =
 ('Sergey Bulba','X-agon','X-agon','X-agon','X-agon','David Willis',
  'Graham Goring','Graham Goring','Graham Goring','Graham Goring',
  'bcass','bcass','Exocet','Exocet','Roman Morozov');

type
    TSelIconProc = procedure(n:integer) of object;
    TIconSelector = class
    IcGrp:TGroupBox;
    IcImg:TImage;
    IconUpDown:TUpDown;
    AuthLB,AuthName:TLabel;
    constructor Create(AOwner:TWinControl);
    destructor Destroy; override;
    procedure ShowIcon;
    procedure IconUpDownClick(Sender: TObject; Button: TUDBtnType);
    public
    DoSelectIcon:TSelIconProc;
    end;

    TForm6 = class(TForm)
    PageControl1: TPageControl;
    GenTools: TTabSheet;
    GroupBox1: TGroupBox;
    CheckBox40: TCheckBox;
    GroupBox5: TGroupBox;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    GroupBox6: TGroupBox;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    GroupBox10: TGroupBox;
    Button10: TButton;
    Button11: TButton;
    GroupBox11: TGroupBox;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    GroupBox12: TGroupBox;
    Label8: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit3: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    Button12: TButton;
    Button13: TButton;
    GroupBox13: TGroupBox;
    Edit4: TEdit;
    CheckBox38: TCheckBox;
    Button14: TButton;
    FTypTools: TTabSheet;
    SearchTool: TTabSheet;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    DName: TEdit;
    GroupBox3: TGroupBox;
    CheckBox9: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox1: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox33: TCheckBox;
    Protokol: TMemo;
    ProgressBar1: TProgressBar;
    Button3: TButton;
    Memo1: TMemo;
    Button8: TButton;
    Button9: TButton;
    FIDOTools: TTabSheet;
    Label2: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    CheckBox29: TCheckBox;
    CheckBox41: TCheckBox;
    CheckBox42: TCheckBox;
    CheckBox43: TCheckBox;
    Button16: TButton;
    Button4: TButton;
    Button7: TButton;
    CheckBox57: TCheckBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    ColorDialog1: TColorDialog;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ListBox4: TListBox;
    Button5: TButton;
    Button6: TButton;
    Button15: TButton;
    Button17: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure AllEnable;
    function CloseQuery:boolean;override;
    procedure Button4Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure RadioButton7Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    function CheckRegistration(S1:PChar;Ind:integer):boolean;
    function RegisterFile(S1:PChar;Ind:integer):boolean;
    function UnRegisterFile(S1:PChar;Ind:integer):boolean;
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    function CheckRegPath(a:integer):boolean;
    procedure SetIfRegPath;
    procedure RadioButton8Click(Sender: TObject);
    procedure RadioButton9Click(Sender: TObject);
    procedure RadioButton10Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure CheckBox38Click(Sender: TObject);
    procedure Edit4Exit(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox40Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure SelectMenuIcon(n:integer);
    procedure SelectMusIcon(n:integer);
    procedure SelectSkinIcon(n:integer);
    procedure SelectListIcon(n:integer);
    procedure SelectBASSIcon(n:integer);
    procedure Label1Click(Sender: TObject);
    procedure Label12Click(Sender: TObject);
    procedure Label13Click(Sender: TObject);
    procedure Label14Click(Sender: TObject);
    procedure Label15Click(Sender: TObject);
    procedure Label16Click(Sender: TObject);
    procedure Label18Click(Sender: TObject);
    procedure Label19Click(Sender: TObject);
    procedure Label17Click(Sender: TObject);
    function ChangePLColor(var Color:TColor):boolean;
    procedure ListBox1Click(Sender: TObject);
    procedure RegisterGroup(rt:boolean;t:integer;lb:TListBox;All:boolean);
    procedure ListBox2Click(Sender: TObject);
    procedure ListBox3Click(Sender: TObject);
    procedure ListBox4Click(Sender: TObject);
    procedure CreateIcSel(IcSel:TIconSelector;AOwner:TWinControl;SelIconProc:TSelIconProc;x,y:integer;const Name:string;IcNum:integer);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  RegAudio:boolean;
  RegPlaylist:boolean;
  RegSkin:boolean;
  RegBASS:boolean;
  AppIcSel,TrayIcSel,StartIcSel,
  MusIcSel,SkinIcSel,ListIcSel,BASSIcSel:TIconSelector;
  end;

procedure SaveDefaultDir2(subKeyHnd1:integer);
function GetIconHandle(n:integer):HICON;

var
  Form6: TForm6;

const

MyKeys:array[0..3]of string=
('AY_Emul Audio File','AY_Emul Playlist File',
 'AY_Emul Skin File','AY_Emul BASS File');

implementation

{$R *.DFM}

uses ChanDir, MainWin, Mixer, WaveOutAPI, AY, Z80, Players, PlayList;

procedure TForm6.Button2Click(Sender: TObject);
begin
with TChngDir.Create(Self) do
  try
    if Russian_Interface then
     begin
      Caption := '  ';
      Button2.Caption:= ''
     end
    else
     begin
      Caption := 'Select folder';
      Button2.Caption := 'Cancel'
     end;
    if DirectoryExists(DName.Text) then
     DirectoryListBox1.Directory := DName.Text;
    DirName.Text := DirectoryListBox1.Directory;
    ShowModal;
    if ModalResult = mrOk then DName.Text := DirName.Text
  finally
    Free
  end
end;

procedure TForm6.Button1Click(Sender: TObject);
begin
if Russian_Interface then
 Form1.OpenDialog1.Filter := ' |*.*'
else
 Form1.OpenDialog1.Filter := 'All files|*.*';
Form1.OpenDialog1.Filter := Form1.OpenDialog1.Filter +
 '|SNA|*.sna|TRD, TD0, FDI, SCL|*.trd;*.scl;*.fdi;*.td0|BIN|*.bin|TAP, TZX|' +
 '*.tap;*.tzx';
if Form1.OpenDialog1.Execute then
 begin
  Memo1.Lines := Form1.OpenDialog1.Files;
  Form1.OpenDialog1.FileName := ''
 end
end;

procedure TForm6.Button3Click(Sender: TObject);
begin
if FinderWorksNow then
 begin
  May_Quit := True;
  AllEnable;
 end
else
 begin
  if Russian_Interface then
   Button3.Caption := Lan_Tools_Stop_Ru
  else
   Button3.Caption := Lan_Tools_Stop_En;
  Memo1.ReadOnly := True;
  DName.ReadOnly := True;
  Button1.Enabled := False;
  Button2.Enabled := False;
  Button4.Enabled := False;
  GroupBox1.Enabled := False;
  GroupBox3.Enabled := False;
  GroupBox5.Enabled := False;
  GroupBox6.Enabled := False;
  GroupBox10.Enabled := False;
  Protokol.Clear;
  FindModules
 end
end;

Procedure TForm6.AllEnable;
begin
FinderWorksNow := False;
if Russian_Interface then
 Button3.Caption := Lan_Tools_Begin_Ru
else
 Button3.Caption := Lan_Tools_Begin_En;
Memo1.ReadOnly := False;
DName.ReadOnly := False;
Button1.Enabled := True;
Button2.Enabled := True;
Button4.Enabled := True;
GroupBox1.Enabled := True;
GroupBox3.Enabled := True;
GroupBox5.Enabled := True;
GroupBox6.Enabled := True;
GroupBox10.Enabled := True
end;

procedure TForm6.Button4Click(Sender: TObject);
begin
PostMessage(Handle,WM_CLOSE,0,0)
end;

function TForm6.CloseQuery:boolean;
begin
Result := not FinderWorksNow;
if Result then
 begin
  if ButTools.Is_On then ButTools.Switch_Off;
  ToolsY := Top;
  ToolsX := Left
 end
end;

procedure TForm6.RadioButton3Click(Sender: TObject);
begin
Form1.SetPriority(IDLE_PRIORITY_CLASS)
end;

procedure TForm6.RadioButton4Click(Sender: TObject);
begin
Form1.SetPriority(NORMAL_PRIORITY_CLASS)
end;

procedure TForm6.RadioButton5Click(Sender: TObject);
begin
Form1.SetPriority(HIGH_PRIORITY_CLASS)
end;

procedure TForm6.RadioButton6Click(Sender: TObject);
begin
if not Russian_Interface then Form1.SwapLan
end;

procedure TForm6.RadioButton7Click(Sender: TObject);
begin
if Russian_Interface then Form1.SwapLan
end;

procedure TForm6.Button7Click(Sender: TObject);
var
 i,j:integer;
 MyRegPath:string;
 subKeyHnd1:HKey;
begin
Uninstall := True;
//Form1.RemoveOldPaths;
MyRegPath := MyRegPath1 + '\' + MyRegPath2 + '\' + MyRegPath3 + #0;
i := RegDeleteKey(HKEY_CURRENT_USER,PChar(MyRegPath));
if i <> ERROR_FILE_NOT_FOUND then
 CheckRegError(i);
MyRegPath[Length(MyRegPath1) + Length(MyRegPath2) + 2] := #0;
i := RegOpenKeyEx(HKEY_CURRENT_USER,PChar(MyRegPath),0,KEY_ALL_ACCESS,subKeyHnd1);
if i <> ERROR_FILE_NOT_FOUND then
 CheckRegError(i);
if i = ERROR_SUCCESS then
 begin
  try
   CheckRegError(RegQueryInfoKey(subKeyHnd1,nil,nil,nil,@i,nil,nil,@j,nil,nil,nil,nil));
  finally
   RegCloseKey(subKeyHnd1);
  end;
  if (i = 0) and (j = 0) then
   CheckRegError(RegDeleteKey(HKEY_CURRENT_USER,PChar(MyRegPath)));
 end;
MyRegPath[Length(MyRegPath1) + 1] := #0;
i := RegOpenKeyEx(HKEY_CURRENT_USER,PChar(MyRegPath),0,KEY_ALL_ACCESS,subKeyHnd1);
if i <> ERROR_FILE_NOT_FOUND then
 CheckRegError(i);
if i = ERROR_SUCCESS then
 begin
  try
   CheckRegError(RegQueryInfoKey(subKeyHnd1,nil,nil,nil,@i,nil,nil,@j,nil,nil,nil,nil));
  finally
   RegCloseKey(subKeyHnd1);
  end;
  if (i = 0) and (j = 0) then
   CheckRegError(RegDeleteKey(HKEY_CURRENT_USER,PChar(MyRegPath)));
 end;
Button9Click(Sender);
ShowMessage('Ay_Emul data is removed from your system. Close the program ' +
            'and delete Ay_Emul folder to complete uninstall. See you!')
end;

procedure StartMenuLink(ChangeIcon:boolean);
var
 AnObj:IUnknown;
 ShLink:IShellLink;
 PFile:IPersistFile;
 StartMenuDir,MyProgramPath:string;
 ShCutPath:WideString;
 Pidl:PItemIDList;
 F:file;
begin
SetLength(StartMenuDir, MAX_PATH + 1);
if (SHGetSpecialFolderLocation(Application.Handle, CSIDL_PROGRAMS,Pidl)
    = NOERROR) and SHGetPathFromIDList(Pidl, PChar(StartMenuDir)) then
 begin
  StartMenuDir := StrPas(PChar(StartMenuDir));
  ShCutPath := StartMenuDir + '\AY Emulator.lnk';
  if not FileExists(ShCutPath) then
   begin
    if ChangeIcon then exit
   end
  else
   begin
    AssignFile(F,ShCutPath);
    Erase(F)
   end;
  MyProgramPath := ParamStr(0);
  AnObj := CreateComObject(CLSID_ShellLink);
  ShLink := AnObj as IShellLink;
  PFile := AnObj as IPersistFile;
  ShLink.SetPath(PChar(MyProgramPath));
  ShLink.SetWorkingDirectory(PChar(ExtractFileDir(MyProgramPath)));
  ShLink.SetIconLocation(PChar(MyProgramPath),MenuIconNumber);
  PFile.Save(PWChar(ShCutPath), False)
 end
end;

procedure TForm6.SelectMenuIcon(n:integer);
begin
if MenuIconNumber = n then exit;
MenuIconNumber := n;
StartMenuLink(True)
end;

procedure TForm6.Button10Click(Sender: TObject);
begin
StartMenuLink(False)
end;

procedure TForm6.Button11Click(Sender: TObject);
var
 Pidl:PItemIDList;
 StartMenuDir:string;
 F:file;
begin
SetLength(StartMenuDir, MAX_PATH + 1);
if (SHGetSpecialFolderLocation(Application.Handle, CSIDL_PROGRAMS,Pidl)
    = NOERROR) and SHGetPathFromIDList(Pidl, PChar(StartMenuDir)) then
 begin
  StartMenuDir := StrPas(PChar(StartMenuDir)) + '\AY Emulator.lnk';
  if FileExists(StartMenuDir) then
   begin
    AssignFile(F,StartMenuDir);
    Erase(F)
   end
 end
end;

function TForm6.CheckRegPath(a:integer):boolean;
var
 DataStr:string;
 i,j,size:integer;
 subKeyHnd1:HKey;
begin
Result := False;
DataStr := MyKeys[a];
DataStr := DataStr + '\shell\open\command'#0;
i := RegOpenKeyEx(HKEY_CLASSES_ROOT,PChar(DataStr),0,KEY_ALL_ACCESS,subKeyHnd1);
if i <> ERROR_SUCCESS then
 begin
  if i <> ERROR_FILE_NOT_FOUND then CheckRegError(i);
  exit
 end;
try
 i := RegQueryValueEx(subKeyHnd1,nil,nil,@j,nil,@size);
 CheckRegError(i);
 if j = REG_SZ then
  begin
   SetLength(DataStr,size);
   i := RegQueryValueEx(subKeyHnd1,nil,nil,@j,PByte(DataStr),@size);
   CheckRegError(i);
   if a <> 2 then
    Result := AnsiLowerCase(DataStr) =
                        AnsiLowerCase('"' + ParamStr(0) + '" "%1"'#0)
   else
    Result := AnsiLowerCase(DataStr) =
                        AnsiLowerCase('"' + ParamStr(0) + '" /p"%1"'+#0)
  end
finally
 RegCloseKey(subKeyHnd1)
end
end;

procedure TForm6.SetIfRegPath;
begin
RegAudio := CheckRegPath(0);
RegPlaylist := CheckRegPath(1);
RegSkin := CheckRegPath(2);
RegBASS := CheckRegPath(3)
end;

procedure TForm6.RadioButton8Click(Sender: TObject);
begin
TrayMode := 0;
Form1.RemoveTrayIcon;
ShowWindow(Application.Handle,SW_SHOW)
end;

procedure TForm6.RadioButton9Click(Sender: TObject);
begin
TrayMode := 1;
Form1.AddTrayIcon;
ShowWindow(Application.Handle,SW_HIDE)
end;

procedure TForm6.RadioButton10Click(Sender: TObject);
begin
TrayMode := 2;
Form1.RemoveTrayIcon;
ShowWindow(Application.Handle,SW_SHOW)
end;

procedure TForm6.Button12Click(Sender: TObject);
var
 tmp:integer;
 s,s1:string;
begin
s := Form1.OpenDialog1.FileName;
s1 := Form1.OpenDialog1.InitialDir;
Form1.OpenDialog1.FileName := '';
tmp := Form1.OpenDialog1.FilterIndex;
Form1.OpenDialog1.FilterIndex := 1;
Form1.OpenDialog1.Options := [ofHideReadOnly,ofEnableSizing];
if Russian_Interface then
 Form1.OpenDialog1.Filter:='  (AYS)|*.ays'
else
 Form1.OpenDialog1.Filter:='Skin files (AYS)|*.ays';
if Form1.SkinDirectory <> '' then
 Form1.OpenDialog1.InitialDir := Form1.SkinDirectory;
if Form1.OpenDialog1.Execute then
 begin
  Form1.SkinDirectory := ExtractFileDir(Form1.OpenDialog1.FileName);
  Form1.LoadSkin(Form1.OpenDialog1.FileName,False);
  Form1.Repaint
 end;
Form1.OpenDialog1.InitialDir := s1; 
Form1.OpenDialog1.FilterIndex := tmp;
Form1.OpenDialog1.FileName := s;
Form1.OpenDialog1.Options :=
                 [ofHideReadOnly,ofAllowMultiSelect,ofEnableSizing]
end;

procedure TForm6.Button13Click(Sender: TObject);
begin
if Form1.Is_Skined then
 begin
  Form1.LoadSkin('',False);
  Form1.Repaint
 end
end;

procedure TForm6.CheckBox38Click(Sender: TObject);
begin
AutoSaveDefDir := CheckBox38.Checked
end;

procedure TForm6.Edit4Exit(Sender: TObject);
var
 s:string;
begin
s := Trim(Edit4.Text);
if DirectoryExists(s) then
 Form1.DefaultDirectory := s
end;

procedure TForm6.Button14Click(Sender: TObject);
var
 i:integer;
 MyRegPath:string;
 CreateStatus:longword;
 subKeyHnd1:HKey;
begin
MyRegPath := MyRegPath1 + '\' + MyRegPath2 + '\' + MyRegPath3 + #0;
i := 0;
CheckRegError(RegCreateKeyEx(HKEY_CURRENT_USER,PChar(MyRegPath),0,@i,
     REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,nil,subKeyHnd1,@CreateStatus));
try
 SaveDefaultDir2(subKeyHnd1)
finally
 RegCloseKey(subKeyHnd1)
end
end;

procedure TForm6.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action := caFree;
AppIcSel.Free;
TrayIcSel.Free;
StartIcSel.Free;
MusIcSel.Free;
SkinIcSel.Free;
ListIcSel.Free;
BASSIcSel.Free
end;

procedure TForm6.CreateIcSel(IcSel:TIconSelector;AOwner:TWinControl;SelIconProc:TSelIconProc;x,y:integer;const Name:string;IcNum:integer);
begin
IcSel := TIconSelector.Create(AOwner);
with IcSel do
 begin
  DoSelectIcon := SelIconProc;
  IcGrp.Top := y;
  IcGrp.Left := x;
  IcGrp.Caption := Name;
  IconUpDown.Position := IcNum;
  ShowIcon
 end
end;

procedure TForm6.FormCreate(Sender: TObject);

 procedure AddExt(i:Available_Types;t:integer;lb:TListBox);
 var
  j:Available_Types;
  n:integer;
  f:boolean;
 begin
  f := False;
  for j := MinAYChipFile to Pred(i) do
   if SExts[i] = SExts[j] then
    begin
     f := True;
     break
    end;
  if not f then
   begin
    n := lb.Items.Add(SExts[i]);
    if CheckRegistration(PChar(LowerCase(SExts[i])),t) then
     lb.Selected[n] := True
   end;
 end;

var
 i:Available_Types;
begin
if ToolsX <> MaxInt then
 begin
  Top := ToolsY;
  Left := ToolsX
 end
else
 Position := poScreenCenter;

CreateIcSel(AppIcSel,GenTools,Form1.SelectAppIcon,210,227,'Application icon',AppIconNumber);
CreateIcSel(TrayIcSel,GenTools,Form1.SelectTrayIcon,108,227,'Tray icon',TrayIconNumber);
CreateIcSel(StartIcSel,GenTools,SelectMenuIcon,6,227,'''Start'' menu icon',MenuIconNumber);
CreateIcSel(MusIcSel,FTypTools,SelectMusIcon,8,8,'Music files icon',MusIconNumber);
CreateIcSel(SkinIcSel,FTypTools,SelectSkinIcon,376,152,'Skin files icon',SkinIconNumber);
CreateIcSel(ListIcSel,FTypTools,SelectListIcon,376,8,'Playlists icon',ListIconNumber);
CreateIcSel(BASSIcSel,FTypTools,SelectBASSIcon,192,8,'BASS files icon',BASSIconNumber);

ListBox1.ControlStyle := ListBox1.ControlStyle - [csDoubleClicks];
ListBox2.ControlStyle := ListBox2.ControlStyle - [csDoubleClicks];
ListBox3.ControlStyle := ListBox3.ControlStyle - [csDoubleClicks];
ListBox4.ControlStyle := ListBox4.ControlStyle - [csDoubleClicks];

SetIfRegPath;
for i := MinAYChipFile to MaxAYChipFile do
 AddExt(i,0,ListBox1);
AddExt(CDAFile,0,ListBox1);
for i := MIDFileMin to MIDFileMax do
 AddExt(i,0,ListBox1);
ListBox1.Selected[ListBox1.Items.Add('.MIDI')] := CheckRegistration('.midi',0);
for i := BASSFileMin to BASSFileMax do
 AddExt(i,3,ListBox2);
ListBox3.Selected[ListBox3.Items.Add('.AYL')] := CheckRegistration('.ayl',1);
ListBox3.Selected[ListBox3.Items.Add('.M3U')] := CheckRegistration('.m3u',1);
ListBox4.Selected[ListBox4.Items.Add('.AYS')] := CheckRegistration('.ays',2);
end;

procedure TForm6.CheckBox40Click(Sender: TObject);
begin
AutoSaveWindowsPos := CheckBox40.Checked
end;

procedure SaveDefaultDir2;
var
 i:integer;
 DefDir:string;
begin
if Form1.DefaultDirectory = '' then exit;
if AnsiLowerCase(Form1.DefaultDirectory) <> AnsiLowerCase(ExtractFileDir(ParamStr(0))) then
 begin
  DefDir := ExtractFileDrive(Form1.DefaultDirectory);
  if (DefDir <> '') and (DefDir[1] in ['a'..'z','A'..'Z']) and
     (GetDriveType(PChar(DefDir + '\')) = DRIVE_FIXED) then
   begin
    DefDir := Form1.DefaultDirectory + #0;
    i := Length(DefDir);
    i := RegSetValueEx(subKeyHnd1,'DefaultDirectory',0,REG_SZ,PChar(DefDir),i);
    CheckRegError(i)
   end 
 end
else
 begin
  i := RegDeleteValue(subKeyHnd1,'DefaultDirectory');
  if i <> ERROR_FILE_NOT_FOUND then
   CheckRegError(i)
 end
end;

procedure TForm6.Button16Click(Sender: TObject);
begin
with Form1 do
 begin
  FIDO_Descriptor_Enabled := CheckBox29.Checked;
  FIDO_Descriptor_KillOnNothing := CheckBox42.Checked;
  FIDO_Descriptor_KillOnExit := CheckBox41.Checked;
  FIDO_Descriptor_WinEnc := CheckBox43.Checked;
  FIDO_Descriptor_Prefix := Edit6.Text;
  FIDO_Descriptor_Suffix := Edit7.Text;
  FIDO_Descriptor_Nothing := Edit8.Text;
  FIDO_Descriptor_Filename := Edit5.Text;
  if IsPlaying and not Paused then
   FIDO_SaveStatus(FIDO_Playing)
  else
   FIDO_SaveStatus(FIDO_Nothing)
 end
end;

procedure TIconSelector.ShowIcon;
var
 Ic:TIcon;
begin
Ic := TIcon.Create;
Ic.ReleaseHandle;
Ic.Handle := GetIconHandle(IconUpDown.Position);
IcImg.Picture.Assign(Ic);
Ic.Free;
AuthName.Caption := IconAuthors[IconUpDown.Position]
end;

procedure TIconSelector.IconUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
ShowIcon;
DoSelectIcon(IconUpDown.Position)
end;

constructor TIconSelector.Create;
begin
inherited Create;
IcGrp := TGroupBox.Create(AOwner);
IcGrp.Width := 97;
IcGrp.Height := 81;
IcImg := TImage.Create(IcGrp);
IcImg.Parent := IcGrp;
IcImg.Width := 32;
IcImg.Height := 32;
IcImg.Top := 16;
IcImg.Left := 24;
IconUpDown := TUpDown.Create(IcGrp);
IconUpDown.Parent := IcGrp;
IconUpDown.Height := 32;
IconUpDown.Top := 16;
IconUpDown.Left := 56;
IconUpDown.Max := NOfIcons;
IconUpDown.OnClick := IconUpDownClick;
AuthLB := TLabel.Create(IcGrp);
AuthLB.Parent := IcGrp;
AuthLB.Left := 32;
AuthLB.Top := 48;
AuthLB.Caption := 'Author:';
AuthName := TLabel.Create(IcGrp);
AuthName.Parent := IcGrp;
AuthName.Alignment := taCenter;
AuthName.AutoSize := False;
AuthName.Left := 8;
AuthName.Top := 64;
AuthName.Width := 81;
AuthName.Height := 13;
IcGrp.Parent := AOwner
end;

destructor TIconSelector.Destroy;
begin
try
 AuthName.Free;
 AuthLB.Free;
 IconUpDown.Free;
 IcImg.Free;
 IcGrp.Free
finally
 inherited
end
end;

function GetIconHandle;
var
 p:PChar;
begin
if n = 0 then
 p := 'MAINICON'
else
 p := pointer(n);
Result := LoadIcon(hInstance,p)
end;

procedure RegisterType(n:integer);
const
 RTypes:array[boolean,0..3] of string =
 (('AY/YM Audio File'#0,
   'AY/YM Emulator Playlist File'#0,
   'AY Emulator Skin File'#0,
   'AY_Emul&BASS Audio File'#0),
  ('  AY/YM'#0,
   '  AY/YM '#0,
   '   AY'#0,
   '  AY_Emul&BASS'#0));
var
 i:integer;
 DataStr:string;
 subKeyHnd1,subKeyHnd2:HKey;
 CreateStatus:longword;
begin
DataStr := MyKeys[n] + #0;
i := 0;
i := RegCreateKeyEx(HKEY_CLASSES_ROOT,PChar(DataStr),0,@i,
       REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,nil,subKeyHnd1,@CreateStatus);
CheckRegError(i);
try
 DataStr := RTypes[Russian_Interface,n];
 i := Length(DataStr);
 i := RegSetValueEx(subKeyHnd1,nil,0,REG_SZ,PChar(DataStr),i);
 CheckRegError(i);
 i := 0;
 i := RegCreateKeyEx(subKeyHnd1,'DefaultIcon',0,@i,
        REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,nil,subKeyHnd2,@CreateStatus);
 CheckRegError(i);
 try
  DataStr := ParamStr(0) + ',';
  case n of
  0:
   DataStr := DataStr + IntToStr(MusIconNumber);
  1:
   DataStr := DataStr + IntToStr(ListIconNumber);
  2:
   DataStr := DataStr + IntToStr(SkinIconNumber);
  3:
   DataStr := DataStr + IntToStr(BASSIconNumber)
  end;
  i := Length(DataStr);
  i := RegSetValueEx(subKeyHnd2,nil,0,REG_SZ,PChar(DataStr),i);
  CheckRegError(i)
 finally
  RegCloseKey(subKeyHnd2)
 end;
 i := 0;
 i := RegCreateKeyEx(subKeyHnd1,'shell\open\command',0,@i,
        REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,nil,subKeyHnd2,@CreateStatus);
 CheckRegError(i);
 try
  DataStr := '"' + ParamStr(0) + '" ';
  if n = 2 then DataStr := DataStr + '/p';
  DataStr := DataStr + '"%1"'#0;
  i := Length(DataStr);
  i := RegSetValueEx(subKeyHnd2,nil,0,REG_SZ,PChar(DataStr),i);
  CheckRegError(i);
  case n of
  0:
   Form6.RegAudio := True;
  1:
   Form6.RegPlaylist := True;
  2:
   Form6.RegSkin := True;
  3:
   Form6.RegBASS := True
  end
 finally
  RegCloseKey(subKeyHnd2)
 end
finally
 RegCloseKey(subKeyHnd1)
end
end;

procedure TForm6.Button8Click(Sender: TObject);
begin
RegisterGroup(RegAudio,0,ListBox1,True);
RegisterGroup(RegBASS,3,ListBox2,True);
RegisterGroup(RegPlaylist,1,ListBox3,True);
RegisterGroup(RegSkin,2,ListBox4,True)
end;

function TForm6.CheckRegistration(S1:PChar;Ind:integer):boolean;
var
 i:integer;
 RStr:PChar;
 subKeyHnd1:HKey;
begin
Result := False;
if Ind = 0 then if not RegAudio then exit;
if Ind = 1 then if not RegPlaylist then exit;
if Ind = 2 then if not RegSkin then exit;
if Ind = 3 then if not RegBASS then exit;
i := RegOpenKeyEx(HKEY_CLASSES_ROOT,S1,0,KEY_EXECUTE,subKeyHnd1);
if i <> ERROR_SUCCESS then
 begin
  if i <> ERROR_FILE_NOT_FOUND then CheckRegError(i);
  exit
 end;
if RegQueryValueEx(subKeyHnd1,nil,nil,nil,nil,@i) = ERROR_SUCCESS then
 begin
  GetMem(RStr,i);
  if RegQueryValueEx(subKeyHnd1,nil,nil,nil,PByte(RStr),@i) = ERROR_SUCCESS then
   Result := (MyKeys[Ind] = RStr);
  FreeMem(RStr)
 end;
RegCloseKey(subKeyHnd1)
end;

function TForm6.RegisterFile(S1:PChar;Ind:integer):boolean;
var
 i:integer;
 subKeyHnd1:HKey;
 CreateStatus:longword;
 RStr:PChar;
begin
try
 i := 0;
 CheckRegError(RegCreateKeyEx(HKEY_CLASSES_ROOT,S1,0,@i,
       REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,nil,subKeyHnd1,@CreateStatus));
 try
  if RegQueryValueEx(subKeyHnd1,nil,nil,nil,nil,@i) = ERROR_SUCCESS then
   begin
    GetMem(RStr,i);
    try
     if RegQueryValueEx(subKeyHnd1,nil,nil,nil,PByte(RStr),@i) = ERROR_SUCCESS then
      if (StrComp(PChar(MyKeys[Ind] + #0),RStr) <> 0) and (RStr[0] <> #0) then
       CheckRegError(RegSetValueEx(subKeyHnd1,'Before AY_Emul',0,REG_SZ,RStr,i))
    finally
     FreeMem(RStr)
    end
   end;
  CheckRegError(RegSetValueEx(subKeyHnd1,nil,0,REG_SZ,PChar(MyKeys[Ind] + #0),
                 Length(MyKeys[Ind]) + 1));
  Result := True;
 finally
  RegCloseKey(subKeyHnd1)
 end
except
 Result := False
end
end;

function TForm6.UnRegisterFile(S1:PChar;Ind:integer):boolean;
var
 i,j:integer;
 subKeyHnd1:HKey;
 RStr1,RStr2:PChar;
begin
Result := False;
i := RegOpenKeyEx(HKEY_CLASSES_ROOT,S1,0,KEY_ALL_ACCESS,subKeyHnd1);
if i <> ERROR_SUCCESS then
 begin
  if i <> ERROR_FILE_NOT_FOUND then CheckRegError(i);
  exit
 end;
try
 j := RegQueryValueEx(subKeyHnd1,nil,nil,nil,nil,@i);
 if j in [ERROR_SUCCESS,ERROR_FILE_NOT_FOUND] then
  begin
   if j = ERROR_SUCCESS then
    begin
     GetMem(RStr1,i);
     try
      if RegQueryValueEx(subKeyHnd1,nil,nil,nil,PByte(RStr1),@i) = ERROR_SUCCESS then
       if StrComp(RStr1,PChar(MyKeys[Ind] + #0)) = 0 then
        begin
         if RegQueryValueEx(subKeyHnd1,'Before AY_Emul',nil,nil,nil,@i) = ERROR_SUCCESS then
          begin
           GetMem(RStr2,i);
           try
            try
             if RegQueryValueEx(subKeyHnd1,'Before AY_Emul',nil,nil,PByte(RStr2),@i) = ERROR_SUCCESS then
              CheckRegError(RegSetValueEx(subKeyHnd1,nil,0,REG_SZ,RStr2,i));
             exit
            except
            end
           finally
            FreeMem(RStr2);
            RegDeleteValue(subKeyHnd1,'Before AY_Emul')
           end
          end
        end
     finally
      FreeMem(RStr1)
     end;
     try
      CheckRegError(RegDeleteValue(subKeyHnd1,nil));
     except
      Result := True
     end;
    end;
   CheckRegError(RegQueryInfoKey(subKeyHnd1,nil,nil,nil,@i,nil,nil,@j,nil,nil,nil,nil));
   if (i = 0) and (j = 0) then
    begin
     RegCloseKey(subKeyHnd1);
     subKeyHnd1 := 0;
     CheckRegError(RegDeleteKey(HKEY_CLASSES_ROOT,S1))
    end
  end
finally
 if subKeyHnd1 <> 0 then RegCloseKey(subKeyHnd1)
end
end;

procedure TForm6.Button9Click(Sender: TObject);

 procedure UnCheck(i,t:integer;lb:TListBox);
 begin
 lb.Selected[i] := UnRegisterFile(PChar(LowerCase(lb.Items[i])),t)
 end;

var
 i:integer;
begin
for i := 0 to ListBox1.Count - 1 do
 UnCheck(i,0,ListBox1);
for i := 0 to ListBox2.Count - 1 do
 UnCheck(i,3,ListBox2);
for i := 0 to ListBox3.Count - 1 do
 UnCheck(i,1,ListBox3);
for i := 0 to ListBox4.Count - 1 do
 UnCheck(i,2,ListBox4);
end;

procedure TForm6.SelectMusIcon;
begin
if MusIconNumber <> n then
 begin
  MusIconNumber := n;
  RegisterType(0)
 end 
end;

procedure TForm6.SelectSkinIcon;
begin
if SkinIconNumber <> n then
 begin
  SkinIconNumber := n;
  RegisterType(2)
 end
end;

procedure TForm6.SelectListIcon;
begin
if ListIconNumber <> n then
 begin
  ListIconNumber := n;
  RegisterType(1)
 end
end;

procedure TForm6.SelectBASSIcon;
begin
if BASSIconNumber <> n then
 begin
  BASSIconNumber := n;
  RegisterType(3)
 end
end;

function TForm6.ChangePLColor;
begin
ColorDialog1.Color := Color;
Result := ColorDialog1.Execute;
if Result then
 begin
  Color := ColorDialog1.Color;
  RedrawPlaylist(ShownFrom,0,False)
 end 
end;

procedure TForm6.Label1Click(Sender: TObject);
begin
if ChangePLColor(PLColor) then
 begin
  Label1.Font.Color := PLColor;
  Label12.Font.Color := PLColor
 end
end;

procedure TForm6.Label12Click(Sender: TObject);
begin
if ChangePLColor(PLColorBk) then
 begin
  Label1.Color := PLColorBk;
  Label12.Color := PLColorBk;
  Label18.Color := PLColorBk
 end
end;

procedure TForm6.Label13Click(Sender: TObject);
begin
if ChangePLColor(PLColorSel) then
 begin
  Label13.Font.Color := PLColorSel;
  Label14.Font.Color := PLColorSel
 end
end;

procedure TForm6.Label14Click(Sender: TObject);
begin
if ChangePLColor(PLColorBkSel) then
 begin
  Label13.Color := PLColorBkSel;
  Label14.Color := PLColorBkSel;
  Label17.Color := PLColorBkSel;
  Label19.Color := PLColorBkSel
 end
end;

procedure TForm6.Label15Click(Sender: TObject);
begin
if ChangePLColor(PLColorPl) then
 begin
  Label15.Font.Color := PLColorPl;
  Label16.Font.Color := PLColorPl
 end
end;

procedure TForm6.Label16Click(Sender: TObject);
begin
if ChangePLColor(PLColorBkPl) then
 begin
  Label15.Color := PLColorBkPl;
  Label16.Color := PLColorBkPl
 end
end;

procedure TForm6.Label17Click(Sender: TObject);
begin
if ChangePLColor(PLColorPlSel) then Label17.Font.Color := PLColorPlSel
end;

procedure TForm6.Label18Click(Sender: TObject);
begin
if ChangePLColor(PLColorErr) then Label18.Font.Color := PLColorErr
end;

procedure TForm6.Label19Click(Sender: TObject);
begin
if ChangePLColor(PLColorErrSel) then Label19.Font.Color := PLColorErrSel
end;

procedure TForm6.ListBox1Click(Sender: TObject);
begin
RegisterGroup(RegAudio,0,ListBox1,False)
end;

procedure TForm6.ListBox2Click(Sender: TObject);
begin
RegisterGroup(RegBASS,3,ListBox2,False)
end;

procedure TForm6.ListBox3Click(Sender: TObject);
begin
RegisterGroup(RegPlaylist,1,ListBox3,False)
end;

procedure TForm6.ListBox4Click(Sender: TObject);
begin
RegisterGroup(RegSkin,2,ListBox4,False)
end;

procedure TForm6.RegisterGroup(rt:boolean;t:integer;lb:TListBox;All:boolean);
var
 s:string;
 i:integer;
begin
if not rt then RegisterType(t);
for i := 0 to lb.Count - 1 do
 begin
  s := LowerCase(lb.Items[i]);
  if lb.Selected[i] then
   begin
    if All or not CheckRegistration(PChar(s),t) then RegisterFile(PChar(s),t)
   end
  else
   if All or CheckRegistration(PChar(s),t) then UnRegisterFile(PChar(s),t)
 end
end;

procedure TForm6.Button5Click(Sender: TObject);
var
 lb:TListBox;
 i:integer;
begin
case (Sender as TButton).Tag of
0:lb := ListBox1;
1:lb := ListBox2;
2:lb := ListBox3;
3:lb := ListBox4;
else exit;
end;
if lb.SelCount < lb.Count then
 lb.SelectAll
else
 for i := 0 to lb.Count - 1 do
  lb.Selected[i] := False;
lb.OnClick(Sender)
end;

end.
